"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WireProtocolParser = void 0;
const parse_1 = require("./parse");
const stream_1 = require("stream");
class WireProtocolParser extends stream_1.Writable {
    constructor() {
        super();
        this.buffer = [];
        this.currentNeed = 0;
    }
    async _write(chunk, encoding, callback) {
        try {
            this.buffer.push(chunk);
            if (chunk.length < this.currentNeed) {
                this.currentNeed -= chunk.length;
            }
            else {
                const acc = Buffer.concat(this.buffer);
                const result = await parse_1.ParseMessage(acc);
                if ('needBytes' in result) {
                    this.buffer = [acc];
                    this.currentNeed = result.needBytes;
                }
                else {
                    this.emit('message', result.msg);
                    this.buffer = [];
                    this.currentNeed = 0;
                    this._write(acc.subarray(result.readBytes), null, callback);
                    return;
                }
            }
            callback();
        }
        catch (err) {
            callback(err);
        }
    }
}
exports.WireProtocolParser = WireProtocolParser;
//# sourceMappingURL=parse-stream.js.map